variable_delay_after_fix = 500;
variable_delay_before_saccade = 500;
variable_delay_after_saccade = 500;

% stimuli
fp = BoxGraphic(null_);  % fixation point
fp.List = { [1 1 1], [1 1 1], 0.5, [0 0], 1, 0 };

cue = BoxGraphic(null_);  % saccade target
cue.List = { [1 1 1], [1 1 1], 0.5, [5 0], 1, 0 };

list = {'A.bmp',[5 5], 2;
    [], [], 2;
    'B.bmp',[5 5], 2;
    [], [], 2;
    'C.bmp',[5 5], 2;
    [], [], 2;
    'D.bmp',[5 5], 2;
    [], [], 2; };
list = repmat(list,100,1);  % just to make a longer list for demonstration
img = ImageChanger(null_);
img.List = list;

% scene 1
% con1 -- wth1 -- fix1
%    +--- fp
fix1 = SingleTarget(eye_);
fix1.Target = [0 0];
fix1.Threshold = 3;
wth1 = WaitThenHold(fix1);
wth1.WaitTime = 5000;
wth1.HoldTime = variable_delay_after_fix;
con1 = Concurrent(wth1);
con1.add(fp);
scene1 = create_scene(con1);

% scene 2
% con2 -- seq2 -- con2a -- tc2a
%    |       |        +--- fp
%    |       |
%    |       +--- con2b -- wth2b -- fix2b
%    |                +--- cue
%    +--- img
tc2a = TimeCounter(null_);
tc2a.Duration = variable_delay_before_saccade;
con2a = Concurrent(tc2a);
con2a.add(fp);

fix2b = SingleTarget(eye_);
fix2b.Target = [5 0];
fix2b.Threshold = 3;
wth2b = WaitThenHold(fix2b);
wth2b.WaitTime = 5000;
wth2b.HoldTime = variable_delay_after_saccade;
con2b = Concurrent(wth2b);
con2b.add(cue);

seq2 = Sequential(con2a);
seq2.add(con2b);
% The time of Event 30 will be the same as that of Event 20 (start time of
% scene 2). To avoid double-marking, use NaN, like [NaN 40].
seq2.EventMarker = [30 40];
con2 = Concurrent(seq2);
con2.add(img);
scene2 = create_scene(con2);

% run scenes
run_scene(scene1,10);
if wth1.Success
    run_scene(scene2,20);
end
idle(0,[],50);  % saccade target off

if con2b.Success  % or wth2b.Success
    goodmonkey(100,'eventmarker',90);
end
